// Small program to offer a menu with 2 or 3 items and possibly a timeout.
//
// Argument argv[1] is 0 to offer all three items, and 1 to offer only
// the two last items.
//
// Argument argv[2] is the timeout value in seconds after which the first 
// menu item is automatically selected. A value of 0 means no timeout.
//

#include <string.h>
#include <stdlib.h>
#include <misc.h>
#include <dialog.h>
#include <translat.h>

int main (int argc, char *argv[])
{
  argc = dialog_parseuioptions (argc, argv);
  linuxconf_loadlibmsg("linuxconf");
  translat_checkmissing();

  int first_menu_item = atoi(argv[1]);
  int menu_timeout = atoi(argv[2]);

  dialog_clear();

  DIALOG_MENU dia;

  // The graphical login is only available if the terminal is fully configured.
  // Upon booting, the default menu item is automatically selected after
  // a short timeout.

  if(first_menu_item == 0) dia.new_menuitem("Start","graphical login");
  dia.new_menuitem("Configure","terminal");
  dia.new_menuitem("Start","text-mode command shell");
  if(menu_timeout) dialog_settimeout(menu_timeout,MENU_ESCAPE,true);

  int ret = 0;
  int nof = 0;

  while(1) {
    MENU_STATUS code = dia.editmenu("X Terminal",
        "Start or configure the X Terminal", help_nil,nof,0);

    // Nothing was selected.

    if(code == MENU_QUIT || code == MENU_ESCAPE){
        ret = 0 + first_menu_item;
        break;
    }

    // Set the return code to the selection

    else if(code == MENU_OK) {
      nof += first_menu_item;
      if(nof == 0) ret = 0;
      else if(nof == 1) ret = 1;
      else ret = 2;
      break;
    }
  }
  dialog_end();
  return ret;
}
